﻿; AniE 0.3 disk work

TestDOS EQU 8345
Out_DOS EQU 10835
WaitDOS EQU 16117
SaveDOS EQU 16330
LoadDOS EQU 16357

LOADANI
        CALL NC,PUSHPOP
        LD HL,AniSORT
        CALL SELFILE
        JP C,lani_EX
        LD DE,FName             ; копируем DSC
        LD BC,16
        LDIR 
        CALL WRKBANK
        CALL DN_LOAD            ; грузим (часть) файла
        LD HL,UNDOBUF           ; проверка сигнатуры
        LD DE,Header
lani_4  LD A,(DE)
        CP (HL)
        JR NZ,lani_E0
        INC HL
        INC DE
        AND A
        JR NZ,lani_4
        PUSH HL                 ; выводим окошко
        LD HL,EX_txt
        SCF 
        CALL lani_ER
        CALL INIT
        POP HL
        LDB (XSIZE),(HL)        ; выставляем размер
        INC HL
        LD A,(HL)
        LD (YSIZE8),A
        LD B,A
        NEG 
        AND 7
        ADD A,B
        RRA 
        RRA 
        RRA 
        AND #1F
        LD (YSIZE),A
        INC HL
        PUSH HL
        LD C,7
        CALL MONOCHR
        POP HL
lani_5  CALL IMPFRAM            ; импортируем кадры
        JR NC,lani_5
        CALL WRKBANK
        CALL CASHARR
        CALL RESTFON            ; закр.окно импорта
        CALL RESTFON            ; и окно "файл"
        CALL BAR_PAR
        XOR A
        LD (XPOS),A
        LD (YPOS),A
        LD A,(YSIZE)
        ADD A,A
        ADD A,A
        ADD A,A
        LD (YSIZE8),A
        CALL POPFRAM
        CALL savebin
        CALL CLR_ALL
        CALL OUT_ALL
        JP ReFile
lani_E0
        LD HL,E0_txt
        AND A
lani_ER PUSH AF
        PUSH HL
        CALL CASHARR
        LD DE,#FFFF
        POP HL
        PUSH HL
        LD C,1
lae_0   INC C
        LD A,(HL)
        INC HL
        AND A
        JR NZ,lae_0
        LD B,3
        AND A
        CALL WINDOW
        LD HL,#0101
        LD (PrnPos+1),HL
        POP HL
        CALL TEXT
        CALL INITARR
        CALL NOMOVE
        POP AF
        RET C
lae_1   CALL TESTARR
        JR NC,lae_1
lani_E  CALL CASHARR
        CALL WRKBANK
        CALL RESTFON
        CALL INITARR
        CALL NOFIRE
        CALL NOMOVE
lani_EX AND A
        RET 

SELFILE
        LD (SortAdr+1),HL
        CALL CASHARR
        LD DE,#FFFF
        LD BC,#0A13
        AND A
        CALL WINDOW
        LD IX,DiskBut
        CALL OUTBUTZ
        SCF 
        CALL FILEWIN
        CALL CATALOG
        CALL DRIVE_L
        XOR A
        LD (TDF_FLD+1),A
        CALL INITARR
        CALL NOMOVE
lani_3  LD HL,DiskBut
        LD DE,DiskKey
        LD BC,TEST_DF
        OR 2
        CALL TESTBUT
        JR C,self_ER
        LD A,(TDF_FLD+1)        ; берем номер файла
        LD L,A
        LD H,high SORTTAB
        LD A,(UpCat)
        ADD A,L
        LD L,A
        LD A,(HL)
        CP #FF
        JR Z,lani_3
        LD L,A
        LD H,0
        LD DE,FRAMBUF
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,DE
        PUSH HL
        CALL lani_E
        POP HL
        AND A
        RET 
self_ER CALL lani_E
        SCF 
        RET 

FILEWIN PUSH AF
        LD DE,#0401
        LD BC,#080E
        LD A,4
        CALL CLR_BOX
        POP AF
        RET C
        LD E,32
        ADD HL,DE
        LD B,10
fiwi_X  LD (HL),6
        INC L
        DJNZ fiwi_X
        RET 

CLR_BOX PUSH AF
        CALL INWINAT
        EX DE,HL
        POP AF
        LD DE,32
lani_1  PUSH BC
        PUSH HL
lani_2  LD (HL),A
        INC L
        DEC C
        JR NZ,lani_2
        POP HL
        POP BC
        ADD HL,DE
        DJNZ lani_1
        RET 

DiskBut DB 1,1,2,2,38
        DW DRIVE_A
        DB 1,3,2,2,39
        DW DRIVE_B
        DB 1,5,2,2,40
        DW DRIVE_C
        DB 1,7,2,2,41
        DW DRIVE_D
        DB 4,1,14,8,255
        DW 0
        DB 0,0,18,10,255
        DW skip                 ; window
        DB 0,0,255,255,255
        DW EXIT_E
        DB 255
DiskKey
        DB 1
        DW #10EF,CAT_DWN
        DW #08EF,CAT_UP
        DW #01F7,DRIVE_A
        DW #02F7,DRIVE_B
        DW #04F7,DRIVE_C
        DW #08F7,DRIVE_D
        DB 255

Header  DB "GIF animation",0
E0_txt  DB "неизвестный формат",0
EX_txt  DB "импорт...",0

;--------------------
IMPFRAM
        LDB (FDlay),(HL)
        INC L
        CALL Z,IF_NXS
        LDB (FType),(HL)
        INC L
        CALL Z,IF_NXS
        LD A,(FDlay)    ; если delay=(255 or 0)
        INC A
        CP 2
        RET C
        LD A,(FType)    ; or type iz unknown, then exit
        AND 63
        CP 9
        CCF 
        RET C
IF_go   LDB E,(FRAMES)
        LD D,high LISTTAB + 1
        LDB (DE),(FDlay)
        DEC D
        LD A,E
        LD (DE),A
        INC A
        LD (LISTLEN),A
        LDB E,(FType)
        RLA 
        SBC A,A
        AND #90
        XOR #37
        LD (B7I_1),A    ; SCF - нет цвета
        LD (B7I_2),A
        LD A,E
        RLA 
        RLA 
        SBC A,A
        AND #90
        XOR #37
        LD (B6I_1),A
        LD A,E
        AND 31
        SUB 4
        LD D,A
        LD A,#37
        JR C,bassz
        JR Z,bassz
        LD E,D
        LD A,#A7
bassz   LD (B5I_1),A
        LD A,E
        AND 31
        ADD A,A
        LD DE,IFTab
        ADD A,E
        LD E,A
        ADC A,D
        SUB E
        LD D,A
        EX DE,HL
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        EX DE,HL
        CALL CALL_DE
        PUSH HL
        CALL PACKNEW
        POP HL
        AND A
        RET 

IFTab   DW IF_T0
        DW IF_T5X,IF_T6X,IF_T7X,IF_T8X

FDlay   DB 0
FType   DB 0

IF_T0   LD DE,FRAMBUF           ; тип 0 - непакованый
        LDB B,(YSIZE8)
ift0_1  PUSH DE
        LDB C,(XSIZE)
ift0_2  LD A,(HL)
        LD (DE),A
        INC D
        INC L
        CALL Z,IF_NXS
        DEC C
        JR NZ,ift0_2
        POP DE
        INC E
        LD A,(FType)
        RLA 
        JR NC,ift0_4
        LD A,E
        AND 7
        JR NZ,ift0_4
B7I_1   SCF 
        JR C,ift0_4
        PUSH DE
        LD A,E
        RRA 
        RRA 
        RRA 
        AND #1F
        DEC A
        OR #C0
        LD E,A
        LDB C,(XSIZE)
ift0_3  LD A,(HL)
        LD (DE),A
        INC L
        CALL Z,IF_NXS
        INC D
        DEC C
        JR NZ,ift0_3
        POP DE
ift0_4  DJNZ ift0_1
        RET 

IF_T5X  XOR A
        JR ift_57
IF_T6X  XOR A
        JR ift_68
IF_T7X  LD A,#AE
ift_57  LD (dpba_P),A
        LD DE,DPBOX_A
        JR ift_B4
IF_T8X  LD A,#AE
ift_68  LD (dpbb_P),A
        LD DE,DPBOX_B
ift_B4  LD (ifb_adr+1),DE
        LD DE,FRAMBUF
        XOR A
        LD (count57+1),A
        LD A,(YSIZE)
ift5_1  PUSH AF
        LD A,(XSIZE)
ift5_2  PUSH AF
        LD A,(count57+1)
        AND 7
        JR NZ,flag57
B5I_1   SCF 
        LD A,#FF
        JR C,b5i_a
        LD A,(HL)
        INC L
        CALL Z,IF_NXS
b5i_a   LD (flag57+1),A
B6I_1   SCF 
        LD A,#FF
        JR C,b6i_a
        LD A,(HL)
        INC L
        CALL Z,IF_NXS
b6i_a   LD (flag5C+1),A
flag57  LD A,0
        RRA 
        LD (flag57+1),A
        LD B,0
        JR NC,ifb_adr
        LD B,(HL)
        INC L
        CALL Z,IF_NXS
ifb_adr CALL DPBOX_A
count57 LD A,0
        INC A
        LD (count57+1),A
        POP AF
        INC D
        DEC A
        JR NZ,ift5_2
        LD A,E
        ADD A,8
        LD E,A
        LD D,high FRAMBUF
        POP AF
        DEC A
        JR NZ,ift5_1
        RET 

DPBOX_A XOR A           ; распаковка клетки по флагу B
        LD C,A          ; для типов 1,3,5,7 может с цветом
        EXA 
        LD A,8
dpba1_3 EXA 
        RR B
        JR NC,dpba1_4
        LD C,(HL)
        INC L
        CALL Z,IF_NXS
dpba1_4 XOR C
        PUSH AF
        EX DE,HL
dpba_P  NOP             ; #00(#AE) для 1(3) типов
        EX DE,HL
        LD (DE),A
        POP AF
        INC E
        EXA 
        DEC A
        JR NZ,dpba1_3
        JR dpbx_C

DPBOX_B XOR A           ; распаковка клетки по флагу B
        EXA             ; для типов 2,4,6,8 может с цветом
        LD A,8
dpbb2_3 EXA 
        RR B
        JR NC,dpbb2_4
        XOR (HL)
        INC L
        CALL Z,IF_NXS
dpbb2_4 PUSH AF
        EX DE,HL
dpbb_P  NOP 
        EX DE,HL
        LD (DE),A
        POP AF
        INC E
        EXA 
        DEC A
        JR NZ,dpbb2_3
dpbx_C  LD A,E
        SUB 8
        LD E,A
B7I_2   SCF 
        RET C
        LD B,E
        LD A,E
        RRA 
        RRA 
        RRA 
        AND #1F
        OR #C0
        LD E,A
flag5C  LD A,0
        RRA 
        LD (flag5C+1),A
        JR NC,b6i_b
        LD A,(HL)
        LD (DE),A
        INC L
        CALL Z,IF_NXS
b6i_b   LD E,B
        RET 
;------------------------
SAVEANI
        CALL NC,PUSHPOP
        LD A,(LISTLEN)
        AND A
        RET Z
        LD HL,FName
        LD DE,FNamBuf
        LD BC,8
        LDIR 
        CALL CASHARR
        LD DE,#FFFF
        LD BC,#0C13
        AND A
        CALL WINDOW
        LD IX,SaveBut
        CALL OUTBUTZ
        AND A
        CALL FILEWIN
        CALL RUSCAPS
        CALL CATALOG
        CALL PRNFNAM
        CALL DRIVE_L
        XOR A
        LD (TDF_FLD+1),A
        CALL INITARR
        CALL NOMOVE
san_RP  LD HL,SaveBut
        LD DE,SaveKey
        LD BC,TEST_DF
        OR 2
        CALL TESTBUT
        JP C,lani_E
        CALL PUSHPOP
        CALL SRCH_FN
        JR C,san_NEW
        PUSH HL
        LD HL,ConfRWF
        CALL CONF_HL    ; Z - yes, NZ - no
        POP IX
        JR NZ,san_RP
        CALL DEL_IXF    ; удаляем файл под IX
san_NEW
        LD A,(FRAMBUF+#8E4)     ; если более 127 файлов
        CP 128
        JR NC,san_ERR
        INC A
        LD (FRAMBUF+#8E4),A
        CALL WRKBANK
        LD HL,FRAMBUF           ; сохраняем каталог в память
        LD DE,#D700
        LD BC,#0900
        LDIR 
        LD HL,EXP_txt   ; окошко экспорта
        SCF 
        CALL lani_ER
        LD HL,(FRAMBUF+#8E1)
        LD (CurrTRS),HL
        LD (FTRS),HL
        LD HL,0
        LD (FLen),HL
        LD (FLen+1),HL
        CALL EXPORT
        CALL lani_E     ; закрываем окно экспорта
        CALL WRKBANK
        LD HL,(CurrTRS)
        LD (#D700+#8E1),HL
        LD A,(FSLen)
        LD C,A
        LD B,0
        LD HL,(#D700+#8E5)
        AND A
        SBC HL,BC
        LD (#D700+#8E5),HL
        LD HL,#D700
        LD DE,16
snew_1  LD A,(HL)
        AND A
        JR Z,snew_2
        ADD HL,DE
        JR snew_1
snew_2  LD DE,FName
        EX DE,HL
        LD BC,16
        LDIR 
        LD HL,#D700
        LD DE,0
        LD B,9
        CALL SAVE
        JP lani_E

san_ERR LD HL,TMF_err
        AND A
        CALL lani_ER
        JP san_RP

ConfRWF DB 1,2,1,"Переписать?",0
EXP_txt DB "Экспорт на старт...",0
TMF_err DB "Каталог переполнен",0

SaveBut DB 1,1,2,2,38
        DW DRIVE_A
        DB 1,3,2,2,39
        DW DRIVE_B
        DB 1,5,2,2,40
        DW DRIVE_C
        DB 1,7,2,2,41
        DW DRIVE_D
        DB 1,9,2,2,3            ; кнопка SAVE (exit NC)
        DW 0
        DB 4,1,14,8,255         ; поле файлов
        DW DROP_FN
        DB 4,10,10,1,255        ; ввод имени
        DW INP_FN
        DB 0,0,19,12,255        ; window
        DW skip
        DB 0,0,255,255,255      ; вне окна (exit C)
        DW EXIT_E
        DB 255
SaveKey
        DB 255

DEL_IXF LD A,(IX+16)
        AND A
        JR Z,dixf_L
        LD (IX),1
        LD HL,FRAMBUF+#8F4
        INC (HL)
        RET 
dixf_L  LD (IX),0
        LD L,(IX+14)
        LD H,(IX+15)
        LD (FRAMBUF+#8E1),HL
        LD E,(IX+13)
        LD D,0
        LD HL,FRAMBUF+#8E4
        DEC (HL)
        LD HL,(FRAMBUF+#8E5)
        ADD HL,DE
        LD (FRAMBUF+#8E5),HL
        RET 

SRCH_FN LD IX,SORTTAB           ; поиск FName в отсортированых
sfn_CY  LD A,(IX)
        CP 255
        SCF 
        RET Z
        LD L,A
        LD H,0
        LD DE,FRAMBUF
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,DE
        LD DE,FName
        LD B,8
        PUSH HL
sfn_1   LD A,(DE)
        CP (HL)
        JR NZ,sfn_2
        INC HL
        INC DE
        DJNZ sfn_1
        POP HL
        AND A
        RET 
sfn_2   POP HL
        INC IX
        JR sfn_CY

RUSCAPS LD A,(RusFlag)
        RLA 
        SBC A,A
        ADD A,43
        LD (RC_Butz+4),A
        LD A,(CapFlag)
        RLA 
        SBC A,A
        ADD A,21
        LD (RC_Butz+11),A
        LD IX,RC_Butz
        JP OUTBUTZ

RC_Butz DB 15,10,1,1,42
        DW skip
        DB 16,10,1,1,44
        DW skip
        DB 255

INP_FN  CALL NOFIRE
        CALL NOKEY
        CALL CASHARR
        XOR A
inam_0  LD (INP_CRS+1),A
        LD C,#17
        CALL INP_CRS
inam_1  CALL INP_KEY
        CP 32
        JR C,inam_C
        LD C,A
        CP 128
        JR C,CapFlag
        LD HL,ReKeyz
inam_1A LD A,(HL)
        AND A
        JR Z,inam_1
        INC HL
        LD B,(HL)
        INC HL
        CP C
        JR NZ,inam_1A
        LD C,B
CapFlag AND A
        JR NC,RusFlag
        LD A,(RusFlag)
        RLA 
        LD A,C
        JR C,L_caps
        CP "A"-1
        JR lcap_0
L_caps  CP "A"
        JR C,RusFlag
        CP "Z"+1
        JR C,lcap_1
        CP "z"+1
        JR NC,RusFlag
        CP "a"
lcap_0  JR C,RusFlag
lcap_1  XOR 32
        LD C,A
RusFlag AND A                 ; #A7 lat, #37 rus
        JR NC,inam_I
        LD HL,RusTab-32
        LD B,0
        ADD HL,BC
        LD C,(HL)
inam_I  LD HL,FNamBuf
        LD A,(INP_CRS+1)
        ADD A,L
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        LD (HL),C
        CALL PRNFNAM
        JR INP_R
INP_L   LD A,(INP_CRS+1)
        SUB 1
        JR C,inam_1
        JR inpr_1
INP_R   LD A,(INP_CRS+1)
        INC A
        CP 8
        JR NC,inam_1
inpr_1  PUSH AF
        LD C,6
        CALL INP_CRS
        POP AF
        JR inam_0
inam_C  LD C,A
        LD HL,IComTab
icom_1  LD A,(HL)
        AND A
        JR Z,inam_1
        INC HL
        LD E,(HL)
        INC HL
        LD D,(HL)
        INC HL
        CP C
        JR NZ,icom_1
        EX DE,HL
        JP (HL)

INP_BS  LD A,(INP_CRS+1)
        SUB 1
        ADC A,0
        LD HL,FNamBuf
        ADD A,L
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        LD (HL),32
        CALL PRNFNAM
        JR INP_L

RUS_CHA LD A,(RusFlag)
        XOR #90
        LD (RusFlag),A
        CALL RUSCAPS
        CALL NOKEY
        JP inam_1

CAPS_CH LD A,(CapFlag)
        XOR #90
        LD (CapFlag),A
        CALL RUSCAPS
        CALL NOKEY
        JP inam_1

IComTab DBW 6,CAPS_CH
        DBW 7,RUS_CHA
        DBW 8,INP_L
        DBW 9,INP_R
        DBW 12,INP_BS
        DBW 13,inam_E
        DBW 14,inam_ER
        DB 0

ReKeyz  DB 226,"~"
        DB 195,"|"
        DB 205,"\\"
        DB 204,"{"
        DB 203,"}"
        DB 198,"["
        DB 197,"]"
        DB 0

RusTab  DB " !",34,"#$%&'()*+,-./"
        DB "0123456789:;<=>?"
        DB "ЮАБЦДЕФГХИЙКЛМНО"
        DB "ПЯРСТУЖВЬЫЗШЭЩЧъ"
        DB "юабцдефгхийклмно"
        DB "пярстужвьызшэщч"

inam_ER LD HL,FName
        LD DE,FNamBuf
        LD BC,8
        LDIR 
        CALL PRNFNAM
        JR ine_1
inam_E  LD HL,FNamBuf
        LD DE,FName
        LD BC,8
        LDIR 
ine_1   LD C,6
        CALL INP_CRS
        CALL NOKEY
        CALL INITARR
        CALL NOMOVE
        AND A
        RET 

INP_KEY RES 5,(IY+1)
ikey_1  HALT 
        BIT 5,(IY+1)
        JR Z,ikey_1
        LD A,(23560)
        RET 

INP_CRS LD A,0
        LD DE,#050A
        ADD A,D
        LD D,A
        CALL INWINAT
        LD A,C
        LD (DE),A
        RET 

DROP_FN LD A,(TDF_FLD+1)
        LD C,A
        LD A,(UpCat)
        ADD A,C
        LD L,A
        LD H,high SORTTAB
        LD A,(HL)
        CP 255
        RET Z
        LD L,A
        LD H,0
        LD DE,FRAMBUF
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,DE
        PUSH HL
        LD DE,FName
        LD BC,8
        LDIR 
        POP HL
        LD DE,FNamBuf
        LD C,8
        LDIR 
PRNFNAM LD HL,#050A
        LD (PrnPos+1),HL
        LD HL,FNamBuf
        LD B,8
        CALL B_PRN
        AND A
        RET 
EXPORT
        CALL BUFPAGE
        LD HL,ShowBox
        RES 3,(HL)
        LD HL,FRAMBUF           ; для начала зануляем 1й кадр
        LD DE,FRAMBUF+1
        LD BC,#1FFF
        LD (HL),L
        LDIR 
        LD HL,Header
        LD DE,UNDOBUF
        LD BC,14
        LDIR 
        LDB (DE),(XSIZE)
        INC DE
        LDB (DE),(YSIZE8)
        INC DE
        LD HL,LISTTAB
        LD A,(LISTLEN)
exp_1   PUSH AF
        EXX 
        LD HL,FRAMBUF
        LD DE,#C000
        LD BC,#2000
        LDIR 
        EXX 
        PUSH HL
        PUSH DE
        INC H
        LD A,(HL)
        DEC H
        PUSH AF
        LD A,(HL)
        CALL POPFRAM    ; вынимаем кадр
        CALL BUFPAGE
        CALL XORING     ; XOR им его с предыдущим
        CALL TESTPAK    ; получаем в C номер лучшего метода 0-8
testa
        POP AF
        POP DE
        CALL PUT_OUT    ; пишем (delay,type)
        LD A,(NeedCol)  ; b7,type
        AND #80
        JR Z,tsta_X1
        PUSH DE
        LD HL,(Tot_ABC)
        LD H,0
        LD DE,(SameCBC)
        SBC HL,DE
        POP DE
        JR NC,tsta_X1
        OR #40
tsta_X1 OR C
        LD B,A
        PUSH BC
        CALL PUT_OUT
        POP BC
        RL B
        SBC A,A
        AND #90
        XOR #37         ; (0,1)=(#37,#A7)
        LD (B7T_1),A    ; цвет
        LD (B7T_2),A
        RL B
        SBC A,A
        AND #90
        XOR #37
        LD (B6T_1),A    ; прессованый цвет
        LD (B6T_2),A
        LD A,C
        AND 31
        CP 5
        SBC A,A
        AND #90
        XOR #A7
        LD (B5T_1),A    ; с флагами 2 уровня
        LD A,C
        AND 31
        SUB 4
        JR C,tsta_X2
        JR Z,tsta_X2
        LD C,A
tsta_X2 LD B,0          ; и пакуем кадр на DE (!)
        LD HL,PackTab
        ADD HL,BC
        ADD HL,BC
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        CALL CALL_HL
        POP HL
        POP AF
        INC L
        DEC A
        JP NZ,exp_1
        LD A,#FF        ; обозначаем конец
        CALL PUT_OUT
        LD A,#FF
        CALL PUT_OUT

        LD HL,(-UNDOBUF) & 0xffff  ; если надо, дописываем остатки
        ADD HL,DE
        LD A,H
        OR L
        RET Z
        LD C,L
        LD B,H
        LD A,E
        AND A
        JR Z,exp_E2
        XOR A
exp_E1  LD (DE),A
        INC E
        JR NZ,exp_E1
        INC D
exp_E2  LD HL,FSLen
        LD A,D
        SUB high UNDOBUF
        LD D,A
        ADD A,(HL)
        LD (HL),A
        LD HL,(FLen)
        ADD HL,BC
        LD (FLen),HL
        LD B,D
        LD HL,UNDOBUF
        LD DE,(CurrTRS)
        CALL SAVE
        LD (CurrTRS),DE
        RET 

PUT_OUT LD (DE),A
        INC E
        RET NZ
        INC D
        RET NZ
        PUSH AF
        PUSH BC
        PUSH HL
        LD HL,UNDOBUF
        LD DE,(CurrTRS)
        LD B,32
        CALL SAVE
        LD (CurrTRS),DE
        LD A,(FSLen)
        ADD A,32
        LD (FSLen),A
        LD (FLen+1),A
        POP HL
        POP BC
        POP AF
        LD DE,UNDOBUF
        RET 

PackTab
        DW EXP_T0
        DW EXP_T1X,EXP_T2X,EXP_T3X,EXP_T4X

NeedCol DB 0            ; нужен ли поток цвета (0-нет)

EXP_T0
        LD HL,FRAMBUF                   ; RAW sprite
        LDB C,(XSIZE)
        LD A,(YSIZE)
et0_1   PUSH AF
        LD A,8
et0_2   PUSH AF
        LD B,C
        PUSH HL
et0_3   LD A,(HL)
        CALL PUT_OUT
        INC H
        DJNZ et0_3
        POP HL
        POP AF
        INC L
        DEC A
        JR NZ,et0_2
B7T_1   SCF 
        JR C,et0_5
        PUSH HL
        LD A,L
        RRA 
        RRA 
        RRA 
        DEC A
        AND #1F
        OR #C0
        LD L,A
        LD B,C
et0_4   LD A,(HL)
        AND 127
        CALL PUT_OUT
        INC H
        DJNZ et0_4
        POP HL
et0_5   POP AF
        DEC A
        JR NZ,et0_1
        RET 

EXP_T1X LD A,#A7        ; type5: 2-bitpack
        JR et5_RF
EXP_T2X LD A,#37        ; type6: 2-zeropack
et5_RF  LD HL,FRAMBUF
        JR et5_XF
EXP_T3X LD A,#A7        ; type7: xor-2-bitpack
        JR et5_SF
EXP_T4X LD A,#37        ; type8: xor-2-zeropack
et5_SF  LD HL,#C000
et5_XF  LD (FlagTyp),A
        XOR A
        LD (count),A
        LD A,(YSIZE)
et4_1   PUSH AF
        PUSH HL
        LD A,(XSIZE)
et4_2   PUSH AF
        PUSH HL
        PUSH DE
        LD A,(count)    ; DE=BoxBuf+10x(count)
        AND 7
        ADD A,A
        LD E,A
        ADD A,A
        ADD A,A
        ADD A,E
        LD DE,BoxBuf
        ADD A,E
        LD E,A
        ADC A,D
        SUB E
        LD D,A
        CALL GET_BOX
        POP DE
        LD A,0
count   EQU $-1
        INC A
        LD (count),A
        AND 7
        LD A,8
        CALL Z,GET_8BX  ; из каждых 8 боксов делаем блок
        POP HL
        INC H
        POP AF
        DEC A
        JR NZ,et4_2
        POP HL
        LD A,L
        ADD A,8
        LD L,A
        POP AF
        DEC A
        JR NZ,et4_1
        LD A,(count)
        NEG 
        ADD A,8
        AND 7
        RET Z
        LD B,A
        LD A,(count)
        AND 7
        ADD A,A
        LD L,A
        ADD A,A
        ADD A,A
        ADD A,L
        LD HL,BoxBuf
        ADD A,L
        LD L,A
        ADC A,H
        SUB L
        LD H,A
et4_3   LD (HL),0
        LD A,L
        ADD A,10
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        DJNZ et4_3
        LD A,(count)
        AND 7
GET_8BX LD (how_8bx+1),A
        LD BC,#0000     ; C - флаг 2 уровня
        LD HL,BoxBuf    ; B - флаг для цвета
        LD A,8
gbx_1   EXA 
        LD A,(HL)
        AND A
        JR Z,gbx_2
        SCF 
gbx_2   RR C
        LD A,L
        ADD A,9
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        LD A,(HL)
        RLA 
        CCF 
        RR B
        INC HL
        EXA 
        DEC A
        JR NZ,gbx_1
B5T_1   SCF 
        LD A,C
        LD C,#FF
        JR C,B6T_1
        LD C,A
        CALL PUT_OUT
B6T_1   SCF 
        LD A,B
        LD B,#FF
        JR C,gbx_2X
        LD B,A
        CALL PUT_OUT
gbx_2X
        LD HL,BoxBuf
how_8bx LD A,8
gbx_3   EXA 
        RR C
        JR NC,gbx_4
        PUSH BC
        CALL PUT_BOX
        POP BC
        JR gbx_5
gbx_4   PUSH BC
        LD C,0
        CALL et1_6X
        POP BC
gbx_5   EXA 
        DEC A
        JR NZ,gbx_3
        RET 

MainFlg DB 0
BoxBuf  DS 80   ; боксы: флаг, xor'еный бокс, цвет

GET_BOX PUSH DE         ; на DE получаем флаг + XOR-бокс с HL
        INC DE
        PUSH DE
        LD B,H
        LD A,L
        RRA 
        RRA 
        RRA 
        AND #1F
        OR #C0
        LD C,A
        LD A,(BC)
        PUSH AF
        LD BC,#0800
et1_3   LD A,(HL)
        XOR C
        LD (DE),A
        LD C,(HL)
        INC L
        INC DE
        DJNZ et1_3
        POP AF
        LD (DE),A
        POP HL
        CALL GETFLAG
        LD A,D
FlagTyp AND A
        JR NC,et1_5
        LD A,E
et1_5   POP DE
        LD (DE),A
        RET 

PUT_BOX LD C,(HL)       ; с HL по флагу кидаем в файл на DE
        LD A,C
        CALL PUT_OUT
et1_6X  INC HL
        LD B,8
et1_6   RR C
        JR NC,et1_7
        LD A,(HL)
        CALL PUT_OUT
et1_7   INC HL
        DJNZ et1_6
        LD A,(HL)
        INC HL
B7T_2   SCF 
        RET C
B6T_2   SCF 
        JP C,PUT_OUT
        BIT 7,A
        JP Z,PUT_OUT
        RET 

GETFLAG LD BC,#0800     ; D-флаг для 1,3,5,7
        LD DE,0         ; E-флаг для 2,4,6,8
gfla_1  LD A,(HL)
        AND A
        JR Z,gfla_2
        SCF 
gfla_2  RR E
        CP C
        JR Z,gfla_3
        LD C,(HL)
        SCF 
gfla_3  RR D
        INC HL
        DJNZ gfla_1
        RET 

XORING  XOR A                   ; кидаем спрайт по XOR
        LD (NeedCol),A
        LD HL,0                 ; счетчик совпавших цветов
        EXX 
        LD HL,FRAMBUF
        LD DE,#C000
        LD A,(XSIZE)
xor_1   PUSH AF
        LDB B,(YSIZE8)
xor_2   LD A,(DE)
        XOR (HL)
        LD (DE),A
        INC E
        INC L
        DJNZ xor_2
        LDB B,(YSIZE)
        LD L,#C0
        LD E,L
xor_3   LD A,(DE)
        XOR (HL)
        AND 127
        JR Z,xor_4Y
        LD A,#FF
        LD (NeedCol),A
        JR xor_4A
xor_4Y  EXX 
        INC HL
        EXX 
        SET 7,(HL)
xor_4A  LD A,(HL)
        LD (DE),A
        INC E
        INC L
        DJNZ xor_3
        POP AF
        LD E,0
        LD L,E
        INC D
        INC H
        DEC A
        JR NZ,xor_1
        EXX 
        LD (SameCBC),HL
        RET 

TESTPAK LD A,(XSIZE)            ; вычисляем длину каждого кадра
        LD E,A
        LD D,0
        LD HL,0
        LD A,(YSIZE)
        CALL ADDING
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        LD (Size_T0),HL
        ADD HL,HL
        ADD HL,HL
        LD A,L
        AND A
        LD A,H
        JR Z,tpak_0
        INC A
tpak_0  LD (Tot_ABC),A

        LD DE,FRAMBUF           ; тест с FRAMBUF
        CALL TEST_TX
        EXX 
        LD (Size_T1),HL
        LD (Size_T2),DE
        CALL TEST_CR
        LD (Size_T5),HL
        LD (Size_T6),DE
        LD DE,#C000             ; тест с XOR-буфера
        CALL TEST_TX
        EXX 
        LD (Size_T3),HL
        LD (Size_T4),DE
        CALL TEST_CR
        LD (Size_T7),HL
        LD (Size_T8),DE

        LD DE,(Size_T0)
        XOR A
        LD C,A
        LD IX,Size_T1
tpak_1  INC A
        LD L,(IX)
        LD H,(IX+1)
        AND A
        SBC HL,DE
        JR NC,tpak_2
        ADD HL,DE
        EX DE,HL
        LD C,A
tpak_2  INC IX
        INC IX
        CP 8
        JR C,tpak_1
        RET 

TEST_CR PUSH HL         ; коррекция на типы 5-8
        LD HL,(Tot_ABC)
        LD H,0
        LD BC,(ZeroFBC)
        AND A
        SBC HL,BC
        LD B,H
        LD C,L
        POP HL
        ADD HL,BC
        EX DE,HL
        ADD HL,BC
        EX DE,HL
        RET 

TEST_TX EXX 
        LD HL,0         ; счетчик для типов 1,3
        LD DE,0         ; счетчик для типов 2,4
        LD (ZeroFBC),HL
        EXX 
        LD A,(YSIZE)
test_1  PUSH AF
        PUSH DE
        LD A,(XSIZE)
test_2  PUSH AF
        PUSH DE
        CALL GETFLGZ    ; получить флаговые байты (H-1,3 L-2,4)
        LD A,H
        AND A
        JR NZ,test_3
        LD BC,(ZeroFBC)
        INC BC
        LD (ZeroFBC),BC
test_3  EXX 
        INC HL
        INC DE
        EXX 
        LD B,8
test_4  RR H
        JR NC,test_5
        EXX 
        INC HL
        EXX 
test_5  RR L
        JR NC,test_6
        EXX 
        INC DE
        EXX 
test_6  DJNZ test_4
        POP DE
        POP AF
        INC D
        DEC A
        JR NZ,test_2
        POP DE
        LD A,E
        ADD A,8
        LD E,A
        POP AF
        DEC A
        JR NZ,test_1
        RET 

GETFLGZ LD HL,0
        EX DE,HL
        XOR A
        LD BC,#0800
gflg_1  XOR (HL)
        JR Z,gflg_2
        SCF 
gflg_2  RR E
        CP C
        JR Z,gflg_3
        LD C,A
        SCF 
gflg_3  RR D
        LD A,(HL)
        INC L
        DJNZ gflg_1
        EX DE,HL
        RET 

SameCBC DW 0            ; совпавшие цвета
ZeroFBC DW 0            ; счетчик нулевых флаговых байт
Tot_ABC DB 0            ; всего контрольных байт

Size_T0 DW 0            ; длины при тестовой упаковке
Size_T1 DW 0
Size_T2 DW 0
Size_T3 DW 0
Size_T4 DW 0
Size_T5 DW 0
Size_T6 DW 0
Size_T7 DW 0
Size_T8 DW 0
Size_T9 DW 0

EF_dlay DB 0            ; длительность кадра
EXP_buf DS 9
;------------------------
IF_NXS  INC H
        RET NZ
        PUSH AF
        PUSH BC
        PUSH DE
        CALL DN_LOAD
        POP DE
        POP BC
        POP AF
        LD HL,UNDOBUF
        RET 

DN_LOAD LD A,(FSLen)
        AND A
        RET Z
        LD B,32
        SUB B
        JR NC,dnl_1
        ADD A,B
        LD B,A
        XOR A
dnl_1   LD (FSLen),A
        LD DE,(FTRS)
        LD HL,UNDOBUF
        CALL LOAD
        LD (FTRS),DE
        RET 
TEST_DF
        CALL ARR_INW
        LD A,D
        SUB 4
        CP 14
        JR NC,tdf_NO
        LD A,E
        DEC A
        CP 8
        JR C,tdf_YE
tdf_NO  LD A,#FF
tdf_YE  LD B,A
        LD A,(TDF_FLD+1)
        CP B
        RET Z
        PUSH BC
        LD C,#04
        CALL TDF_FLD
        POP AF
        LD (TDF_FLD+1),A
        LD C,#17
TDF_FLD LD A,0
        CP #FF
        RET Z
        LD L,A
        LD H,high SORTTAB
        LD A,(HL)
        CP #FF
        RET Z
        LD E,L
        INC E
        LD D,4
        CALL INWINAT
        EX DE,HL
        LD B,14
tfld_1  LD (HL),C
        INC L
        DJNZ tfld_1
        RET 

        RET 

CAT_UP  LD A,(UpCat)
        SUB 1
        CCF 
        RET NC
        LD (UpCat),A
        JR catd_0
CAT_DWN LD A,(UpCat)
        ADD A,8
        LD L,A
        LD H,high SORTTAB
        LD A,(HL)
        CP #FF
        RET Z
        LD HL,UpCat
        INC (HL)
catd_0  CALL CASHARR
        CALL PRN_CAT
        CALL INITARR
        HALT 
        CALL NOMOVE
        AND A
        RET 

DRIVE_A LD A,0
        JR DRIVE_X
DRIVE_B LD A,1
        JR DRIVE_X
DRIVE_C LD A,2
        JR DRIVE_X
DRIVE_D LD A,3
DRIVE_X PUSH AF
        CALL NC,PUSHPOP
        CALL NOKEY
        POP AF
        CALL DRIVE
        CALL CASHARR
        CALL DRIVE_L
        CALL CATALOG
        CALL INITARR
        CALL NOMOVE
        AND A
        RET 

DRIVE_L LD DE,#0101
        CALL INWINAT
        EX DE,HL
        LD DE,31
        LD BC,#0400
drvl_1  LD A,(23798)
        AND 3
        CP C
        LD A,7
        JR Z,drvl_2
        LD A,4
drvl_2  LD (HL),A
        INC L
        LD (HL),A
        ADD HL,DE
        LD (HL),A
        INC L
        LD (HL),A
        ADD HL,DE
        INC C
        DJNZ drvl_1
        RET 

CATALOG
        LD HL,FRAMBUF
        LD DE,0
        LD B,9
        CALL LOAD
SortAdr LD HL,AniSORT
        CALL SORTCAT
        XOR A
        LD (UpCat),A
PRN_CAT
        LD A,(UpCat)
        LD L,A
        LD H,high SORTTAB
        LD DE,#0501
        LD A,8
pcat_1  PUSH AF
        LD (PrnPos+1),DE
        LD A,(HL)
        PUSH HL
        CP #FF
        LD B,8
        LD HL,EmpTy
        JR Z,pcat_2
        LD L,A
        LD H,0
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        LD A,H
        ADD A,high FRAMBUF
        LD H,A
pcat_2  CALL B_PRN
        CALL PRINTS
        LD B,3
        CALL B_PRN
        POP HL
        POP AF
        INC HL
        INC E
        DEC A
        JR NZ,pcat_1
        RET 

B_PRN   LD A,(HL)
        CALL PRINT
        INC HL
        DJNZ B_PRN
        RET 

SORTCAT LD (SortExe+1),HL
        LD HL,SORTTAB
        LD IX,FRAMBUF
        LD BC,#8000
scat_1  LD A,(IX)
        AND A
        JR Z,scat_E
        DEC A
        JR Z,scat_N
SortExe CALL skip
        JR NZ,scat_N
        LD (HL),C
        INC L
scat_N  LD DE,16
        ADD IX,DE
        INC C
        DJNZ scat_1
scat_E  LD B,16
scae_1  LD (HL),#FF
        INC L
        DJNZ scae_1
        RET 

AniSORT LD A,(IX+8)
        CP "a"
        JR Z,aso_1
        CP "A"
        RET NZ
aso_1   LD A,(IX+9)
        CP "n"
        JR Z,aso_2
        CP "N"
        RET NZ
aso_2   LD A,(IX+10)
        CP "i"
        RET Z
        CP "I"
        RET 

EmpTy   DS 11,32
UpCat   DB 0
;-------------------------
LOAD	ld c,5
	jp 15635

;	LD A,#A7
;	JR loas
SAVE
	ld c,6
	jp 15635
/*
        LD A,#37
loas    LD (discom),A
load_0  DI 
        CALL POSIT
        XOR A
        LD (23766),A
load_1  PUSH BC
        PUSH DE
        PUSH HL
        LD A,E
        INC A
        LD C,95
        CALL OUT_DOS

discom  AND A
        PUSH AF
        CALL NC,LOADER
        POP AF
        CALL C,SAVER
        DI 
        POP HL
        POP DE
        POP BC
        LD A,(23766)
        AND A
        JR NZ,diskERR
        INC E
        LD A,E
        CP 16
        JR C,load_2
        LD E,0
        INC D
        CALL POSIT
load_2  INC H
        DJNZ load_1
        AND A
        EI 
        RET 
diskERR CALL RESETC
        CALL RESETC
        CALL RESETC
        LD A,#FE
        IN A,(254)
        RRA 
        JR C,load_0
        LD A,#7F
        IN A,(254)
        RRA 
        JR C,load_0
        SCF 
        EI 
        RET 
POSIT   LD A,0
        AND 3
        OR #3C
        BIT 0,D
        JR Z,LOAD_4
        AND #EF
LOAD_4  LD C,255
        CALL OUT_DOS
        LD A,D
        SRL A
        LD C,127
        CALL OUT_DOS
        LD A,24
        CALL OUT_COM
        CALL WAITDOS
        DI 
        RET 

LOADER  LD A,128
        CALL OUT_COM
        LD C,127
        CALL RD_DOS
        JR IN_1F
SAVER   LD A,160
        CALL OUT_COM
        LD C,127
        CALL WR_DOS
IN_1F   LD BC,IN_1F
        PUSH BC
        LD B,1
        PUSH BC
        PUSH HL
        LD HL,TestDOS
        JR in_dos
*/

DRIVE	ld c,1
	jp 15635

/*
DRIVE   AND 3
        LD (POSIT+1),A
        OR #3C
        LD C,255
        CALL OUT_DOS
        CALL RESETC
        CALL RESETC
        CALL RESETC
RESETC  LD A,8
        CALL OUT_COM
        CALL WAITDOS
        DI 
        XOR A
        LD C,95
        JR OUT_DOS

RD_DOS  PUSH HL
        LD HL,LoadDOS
        JR in_dos

WR_DOS  PUSH HL
        LD HL,SaveDOS
        JR in_dos

WAITDOS PUSH HL
        LD HL,WaitDOS
        JR in_dos

OUT_COM LD C,31
OUT_DOS PUSH HL
        LD HL,Out_DOS
in_dos  EX (SP),HL
        JP 15663
*/
;------------------------
FNamBuf DB "filename"
CurrTRS DW 0

FName   DB "filename"
FExt    DB "ani"
FLen    DW 0
FSLen   DB 0
FTRS    DW 0

