﻿; AniE 0.3 frame work part

REPOPER LD A,(EdiMode)
        AND A
        LD A,(CURFRAM)
        JR Z,POPFRAM
        LD A,(CURPOS)
        LD L,A
        LD H,high LISTTAB
        LD A,(HL)
        LD (CURFRAM),A
POPFRAM LD L,A                  ; вынуть кадр A
        LD H,high FRAMTAB
        LD A,(HL)
        LD (CurSect),A
        CALL SECTADR
        EXX 
        LD DE,FRAMBUF+#C0
        EXX 
        LD DE,FRAMBUF
        LD A,(XSIZE)
pfra_1  PUSH AF
        XOR A
        EXA 
        LD A,(YSIZE)
pfra_2  PUSH AF
        EXA 
        AND 3
        JR NZ,pfra_3
        LD C,(HL)
        INC L
        CALL Z,GONEXT
pfra_3  INC A
        EXA 
        RL C
        JR NC,pfra_6
        RL C
        PUSH BC
        XOR A
        LD B,8
        LD C,(HL)
        INC L
        CALL Z,GONEXT
pfra_4  RL C
        JR NC,pfra_5
        LD A,(HL)
        INC L
        CALL Z,GONEXT
pfra_5  LD (DE),A
        INC E
        DJNZ pfra_4
        POP BC
        JR pfra_8
pfra_6  RL C
        SBC A,A
        LD B,8
pfra_7  LD (DE),A
        INC E
        DJNZ pfra_7
pfra_8  LD A,(HL)
        INC L
        CALL Z,GONEXT
        EXX 
        LD (DE),A
        INC E
        EXX 
        POP AF
        DEC A
        JR NZ,pfra_2
        POP AF
        LD E,0
        INC D
        EXX 
        LD E,#C0
        INC D
        EXX 
        DEC A
        JR NZ,pfra_1
        JP SETPAGE

GONEXT  PUSH AF
        LD A,(CurSect)
        LD L,A
        LD H,high FAT
        LD A,(HL)
        LD (CurSect),A
        CALL SECTADR
        POP AF
        RET 

PACKNEW LD A,(FRAMES)           ; добавить новый
        CP 250
        SCF 
        RET Z
        CALL pack_A
        LD HL,FRAMES
        INC (HL)
        AND A
        RET 

PACKCUR LD A,(CURFRAM)          ; переписать текущий
        CALL DELFAT
        LD A,(CURFRAM)
pack_A  LD L,A
        LD H,high FRAMTAB
        CALL FINDFRE
        LD (HL),E
        LD A,#FF
        LD (DE),A
        LD A,E
        LD (CurSect),A
        CALL SECTADR
        EXX 
        LD DE,FRAMBUF+#C0
        EXX 
        LD DE,FRAMBUF
        LD A,(XSIZE)
pka_1   PUSH AF
        XOR A
        EXA 
        LD A,(YSIZE)
pka_2   PUSH AF
        EXA 
        AND 3
        JR NZ,pka_3
        CALL TEST_4C
        LD (HL),C
        INC L
        CALL Z,NEXTSEC
pka_3   INC A
        EXA 
        RL C
        LD A,8
        JR NC,pka_ND
        PUSH BC
        PUSH DE
        XOR A
        LD BC,#0800
        EX DE,HL
pka_4   CP (HL)
        JR Z,pka_5
        LD A,(HL)
        SCF 
pka_5   RL C
        INC L
        DJNZ pka_4
        EX DE,HL
        POP DE
        LD (HL),C
        INC L
        CALL Z,NEXTSEC
        LD B,8
pka_6   RL C
        JR NC,pka_7
        LD A,(DE)
        LD (HL),A
        INC L
        CALL Z,NEXTSEC
pka_7   INC E
        DJNZ pka_6
        POP BC
        XOR A
pka_ND  ADD A,E
        LD E,A
        RL C
        EXX 
        LD A,(DE)
        INC E
        EXX 
        LD (HL),A
        INC L
        CALL Z,NEXTSEC
        POP AF
        DEC A
        JR NZ,pka_2
        POP AF
        LD E,0
        INC D
        EXX 
        LD E,#C0
        INC D
        EXX 
        DEC A
        JR NZ,pka_1
        JP SETPAGE

TEST_4C PUSH DE
        LD C,0
t4c_1   CALL TEST_00
        LD A,#00
        JR NC,t4c_F
        CALL TEST_FF
        LD A,#40
        JR NC,t4c_F
        LD A,#80
t4c_F   RLA 
        RL C
        RLA 
        RL C
        LD A,E
        ADD A,8
        LD E,A
        AND 31
        JR NZ,t4c_1
        POP DE
        RET 

TEST_00 PUSH DE
        LD B,8
t00_1   LD A,(DE)
        AND A
        SCF 
        JR NZ,t00_E
        INC E
        DJNZ t00_1
t00_Y   AND A
t00_E   POP DE
        RET 

TEST_FF PUSH DE
        LD B,8
tFF_1   LD A,(DE)
        SUB #FF
        JR C,t00_E
        INC E
        DJNZ tFF_1
        JR t00_Y

CurSect DB 0

DELFAT  LD L,A          ; удалить цепочку кадра A
        LD H,high FRAMTAB
        LD L,(HL)
        LD H,high FAT
delf_1  LD A,(HL)
        LD (HL),0
        LD L,A
        CP #FF
        JR NZ,delf_1
        RET 

NEXTSEC PUSH DE         ; HL - на след.своб.сектор от CurSect
        PUSH AF
        LD A,(CurSect)
        LD E,A
        LD D,high FAT
        PUSH DE
        CALL NEXTFRE
        POP HL
        LD A,E
        LD (HL),A
        LD (CurSect),A
        LD A,#FF
        LD (DE),A
        LD A,E
        CALL SECTADR
        POP AF
        POP DE
        RET 

SECTADR PUSH AF         ; поместить HL на адрес сектора A
        RLCA 
        RLCA 
        AND 3
        CALL DATPAGE
        POP AF
        AND 63
        OR #C0
        LD H,A
        LD L,0
        RET 

FINDFRE LD DE,FAT       ; найти первый свободный кластер
NEXTFRE LD A,(DE)
        AND A
        RET Z
        INC E
        LD A,E
        INC A
        JR NZ,NEXTFRE
        SCF 
        RET 

;------------------------
EDIT
        LD A,(FRAMES)
        AND A
        RET Z
        LD A,#FF
        LD (old_X+1),A
        LD (old_Y+1),A
edit_1  CALL TESTARR
        CALL EDPARAM
        LD A,C
        AND #70
        RET Z
        LD A,H
        OR L
        JR Z,edit_1
        LD A,D
old_X   CP #FF
        JR NZ,edit_1A
        LD A,E
old_Y   CP #FF
        JR Z,edit_1
edit_1A LD A,D
        LD (old_X+1),A
        LD A,E
        LD (old_Y+1),A
        BIT 6,C
        JR NZ,edi_AND
        LD A,(EdiType)
        AND A
        JR Z,edi_XOR
        DEC A
        JR Z,edi_OR
edi_AND LD A,B
        CPL 
        AND (HL)
        JR edit_2
edi_OR  LD A,B
        OR (HL)
        JR edit_2
edi_XOR LD A,(HL)
        XOR B
edit_2  PUSH AF
        PUSH HL
        LD A,L
        RRA 
        RRA 
        RRA 
        AND #1F
        OR #C0
        LD L,A
        LD A,0
ShowBox EQU $-1         ; b0 - show box
                        ; b1 - change color
                        ; b2 - buf.frame present
        AND 2
        JR Z,edit_NC
        LD A,(COLOR)
        LD (HL),A
        CALL OUT_ATR
edit_NC CALL OUTVIEW
        POP HL
        POP AF
        CP (HL)
        JR Z,edit_1X
        LD (HL),A
        PUSH AF
        CALL sbox_N
        CALL CASHARR
        LD BC,(ARROWX)
        LD A,B
        AND #FC
        LD B,A
        LD A,C
        SUB 8
        AND #E0
        ADD A,8
        LD C,A
        CALL PT_ADR
        LD D,H
        LD E,L
        POP AF
        CALL OUTBYTE
        CALL OUTVIEW
edit_1X CALL SHOWBOX
        JP edit_1

Masks   DB #80,#40,#20,#10,#08,#04,#02,#01

PUT_ZMB
        LD A,(ShowBox)
        AND 5
        CP 5
        JR NZ,pzmb_E
        LD A,(FRAMES)
        AND A
        JR Z,pzmb_E
        CALL EDPARAM
        LD A,L
        AND #F8
        LD L,A
        CALL BUFPAGE
        LD E,L
        LD A,H
        ADD A,#20
        LD D,A
        LD BC,8
        EX DE,HL
        LDIR 
        LD A,L
        DEC A
        RRA 
        RRA 
        RRA 
        AND #1F
        OR #C0
        LD L,A
        LD E,A
        LDI 
        CALL CASHARR
        CALL sbox_N
        CALL OUTEDIT
        CALL OUTVIEW
        CALL SHOWBOX
pzmb_E  CALL NOKEY
        CALL NOMOVE
        CALL INITARR
        CALL WRKBANK
        AND A
        RET 

EDPARAM LD HL,(ARROWX)  ; D=x, E=y, B=mask, HL=addr
        LD A,L
        SUB 8
        RRA 
        RRA 
        AND 63
        CP 40
        JR NC,edpa_ER
        LD D,A          ; X (bit)
        LD A,(XSIZE)
        ADD A,A
        ADD A,A
        ADD A,A
        DEC A
        CP D
        JR C,edpa_ER
        LD A,H
        SUB 24
        RRA 
        RRA 
        AND 63
        CP 40
        JR NC,edpa_ER
        LD E,A          ; Y
        LD A,(YSIZE8)
        DEC A
        CP E
        JR C,edpa_ER
        LD A,D
        AND 7
        LD HL,Masks
        ADD A,L
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        LD B,(HL)       ; маска
        LD A,D
        RRA 
        RRA 
        RRA 
        AND 31
        LD H,A          ; X (byte)
        LD A,(XPOS)
        ADD A,H
        ADD A,high FRAMBUF
        LD H,A          ; HL : адрес в буфере
        LD A,(YPOS)
        ADD A,A
        ADD A,A
        ADD A,A
        ADD A,E
        LD L,A
        RET 
edpa_ER LD HL,0
        LD B,0
        RET 

MOV_LEF
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        LD DE,FRAMBUF
        LD A,(XSIZE)
        ADD A,high FRAMBUF - 1
        LD H,A
        LD B,H
        LD L,0
        LD A,(YSIZE8)
mlef_1  PUSH AF
        LD A,(DE)
        RLA 
        LD A,(XSIZE)
mlef_2  RL (HL)
        DEC H
        DEC A
        JR NZ,mlef_2
        LD H,B
        INC E
        INC L
        POP AF
        DEC A
        JR NZ,mlef_1
move_E  CALL CASHARR
        CALL OUT_ALL
        CALL INITARR
        JP NOMOVE

MOV_RIG
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        LD HL,FRAMBUF
        LD B,H
        LD A,(XSIZE)
        ADD A,high FRAMBUF - 1
        LD D,A
        LD E,L
        LD A,(YSIZE8)
mrig_1  PUSH AF
        LD A,(DE)
        RRA 
        LD A,(XSIZE)
mrig_2  RR (HL)
        INC H
        DEC A
        JR NZ,mrig_2
        LD H,B
        POP AF
        INC E
        INC L
        DEC A
        JR NZ,mrig_1
        JR move_E

MOV_UP
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        LD DE,FRAMBUF
        LD A,(YSIZE8)
        DEC A
        LD L,A
        LD H,D
        LD B,L
        LD A,(XSIZE)
mup_1   PUSH AF
        LD A,(DE)
        LD C,A
        LD A,(YSIZE8)
mup_2   EXA 
        LD A,(HL)
        LD (HL),C
        LD C,A
        DEC L
        EXA 
        DEC A
        JR NZ,mup_2
        LD L,B
        POP AF
        INC D
        INC H
        DEC A
        JR NZ,mup_1
        JR move_E

MOV_DWN
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        LD HL,FRAMBUF
        LD A,(YSIZE8)
        DEC A
        LD E,A
        LD D,H
        LD A,(XSIZE)
mdwn_1  PUSH AF
        LD A,(DE)
        LD C,A
        LD A,(YSIZE8)
mdwn_2  EXA 
        LD A,(HL)
        LD (HL),C
        LD C,A
        INC L
        EXA 
        DEC A
        JR NZ,mdwn_2
        LD L,0
        POP AF
        INC D
        INC H
        DEC A
        JR NZ,mdwn_1
        JP move_E

FLIP_V
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        LD HL,FRAMBUF
        LD A,(XSIZE)
flpv_1  PUSH AF
        LD L,0
        LD A,(YSIZE8)
        CALL FLIPER
        LD L,#C0
        LD A,(YSIZE)
        CALL FLIPER
        INC H
        POP AF
        DEC A
        JR NZ,flpv_1
        JP move_E

FLIP_H
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        LD HL,FRAMBUF
        LD A,(YSIZE8)
flph_1  PUSH AF
        CALL FLIPIZ
        CALL FLIPBT
        POP AF
        INC L
        DEC A
        JR NZ,flph_1
        LD HL,FRAMBUF+#C0
        LD A,(YSIZE)
flph_2  PUSH AF
        CALL FLIPIZ
        POP AF
        INC L
        DEC A
        JR NZ,flph_2
        JP move_E

FLIPBT  LD H,high FRAMBUF
        LD A,(XSIZE)
flbt_1  LD C,(HL)
        LD B,8
flbt_2  RR C
        RL (HL)
        DJNZ flbt_2
        INC H
        DEC A
        JR NZ,flbt_1
        RET 

FLIPIZ  LD H,high FRAMBUF
        LD A,(XSIZE)
        LD B,A
        LD C,A
fpiz_1  LD A,(HL)
        PUSH AF
        INC SP
        INC H
        DEC C
        JR NZ,fpiz_1
        LD H,high FRAMBUF
fpiz_2  DEC SP
        POP AF
        LD (HL),A
        INC H
        DJNZ fpiz_2
        RET 

FLIPER  LD B,A
        LD C,A
        LD D,L
flpv_2  LD A,(HL)
        PUSH AF
        INC SP
        INC L
        DEC C
        JR NZ,flpv_2
        LD L,D
flpv_3  DEC SP
        POP AF
        LD (HL),A
        INC L
        DJNZ flpv_3
        RET 

CLEAR
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        CALL CLSFRAM
fram_E  CALL CASHARR
        CALL RESTFON
        CALL OUT_ALL
        LD DE,(FramDes+1)
        LD BC,(FramDes+2)
        SCF 
        CALL WINDOW
        CALL INITARR
        CALL NOMOVE
        SCF 
        RET 

CLSFRAM LD HL,FRAMBUF
        LD C,32
        XOR A
clsf_1  LD B,192
clsf_2  LD (HL),A
        INC L
        DJNZ clsf_2
        LD B,24
clsf_3  LD (HL),7
        INC L
        DJNZ clsf_3
        LD L,0
        INC H
        DEC C
        JR NZ,clsf_1
        RET 

MONOCHR LD HL,FRAMBUF + #C0
        LD A,high FRAMBUF + #20 - 1
mono_1  LD (HL),C
        INC L
        JR NZ,mono_1
        INC H
        LD L,#C0
        CP H
        JR NC,mono_1
        RET 
INVERSE
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        LD HL,FRAMBUF
        LD C,32
inve_1  LD B,192
inve_2  LD A,(HL)
        CPL 
        LD (HL),A
        INC L
        DJNZ inve_2
        LD L,0
        INC H
        DEC C
        JR NZ,inve_1
        JR fram_E

ADDFRAM
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        CALL PACKCUR
        CALL CLSFRAM
adfra_1 CALL PACKNEW
        LD A,(FRAMES)
        DEC A
        LD (CURFRAM),A
        LD A,(EdiMode)
        AND A
        JP Z,fram_E
        LD A,(LISTLEN)
        CP 255
        JP NC,fram_E
        LD (CURPOS),A
        LD L,A
        LD H,high LISTTAB
        INC A
        LD (LISTLEN),A
        LD A,(CURFRAM)
        LD (HL),A
        INC H
        LD (HL),5
        JP fram_E

ADDCOPY
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        CALL PACKCUR
        JR adfra_1
GO_NXT
        LD A,(EdiMode)
        AND A
        SCF 
        JR Z,NXTFRAM
        JR NXTPOS
GO_PRV
        LD A,(EdiMode)
        AND A
        SCF 
        JR Z,PRVFRAM
        JR PRVPOS
NXTFRAM
        EXA 
        LD A,(FRAMES)
        AND A
        RET Z
        EXA 
        CALL NC,PUSHPOP
        LD HL,FRAMES
        LD A,(CURFRAM)
        INC A
        CP (HL)
        RET NC
nfra_1  PUSH AF
        CALL PACKCUR
        POP AF
        LD (CURFRAM),A
        CALL POPFRAM
        CALL CASHARR
        CALL OUT_ALL
        CALL INITARR
        CALL NOMOVE
        LD A,(EdiMode)
        AND A
        RET Z
        LD A,(CURPOS)
        LD L,A
        LD H,high LISTTAB
        LDB (HL),(CURFRAM)
        AND A
        RET 
PRVFRAM
        EXA 
        LD A,(FRAMES)
        AND A
        RET Z
        EXA 
        CALL NC,PUSHPOP
        LD A,(CURFRAM)
        SUB 1
        JR NC,nfra_1
        AND A
        RET 
NXTPOS
        EXA 
        CALL TESTLST
        RET Z
        PUSH AF
        EXA 
        CALL NC,PUSHPOP
        POP BC
        LD A,(CURPOS)
        INC A
        CP B
        JR C,nxtp_1
        XOR A
nxtp_1  LD (CURPOS),A
        JR smod_1
PRVPOS
        EXA 
        CALL TESTLST
        RET Z
        PUSH AF
        EXA 
        CALL NC,PUSHPOP
        POP BC
        LD A,(CURPOS)
        SUB 1
        JR NC,nxtp_1
        LD A,B
        DEC A
        JR nxtp_1
INCDLAY
        CALL TESTLST
        RET Z
        CALL PUSHPOP
        LDB L,(CURPOS)
        LD H,high LISTTAB + 1
        LD A,(HL)
        CP 250
        RET NC
        INC (HL)
idla_1  CALL OUTPNUM
        CALL NOMOVE
idla_E  AND A
        RET 
DECDLAY
        CALL TESTLST
        RET Z
        CALL PUSHPOP
        LDB L,(CURPOS)
        LD H,high LISTTAB + 1
        LD A,(HL)
        DEC A
        JR Z,idla_E
        LD (HL),A
        JR idla_1
SETMODE
        EXA 
        LD A,(FRAMES)
        AND A
        RET Z
        EXA 
        CALL NC,PUSHPOP
        LD A,(EdiMode)
        XOR 1
        LD (EdiMode),A
        CALL OUTMODE
        CALL OUTPNUM
        LD A,(EdiMode)
        AND A
        RET Z
        LD A,(CURPOS)
smod_1  LD L,A
        LD H,high LISTTAB
        LD A,(HL)
        PUSH AF
        CALL PACKCUR
        POP AF
        LD (CURFRAM),A
        CALL POPFRAM
        CALL CASHARR
        CALL OUT_ALL
        CALL INITARR
        CALL NOMOVE
        AND A
        RET 

OUTMODE LD A,(SModBut)
        LD D,A
        LD A,(SModBut+1)
        LD E,A
        CALL INWINAT
        EX DE,HL
        LD A,(EdiMode)
        RRA 
        LD A,4
        ADC A,3
        OR 8
        RRA 
        LD DE,31
        LD (HL),A
        INC L
        LD (HL),A
        ADD HL,DE
        LD (HL),A
        INC L
        LD (HL),A
        RET 

TESTLST LD A,(EdiMode)
        AND A
        RET Z
        LD A,(FRAMES)
        AND A
        RET Z
        LD A,(LISTLEN)
        AND A
        RET 

;-------------
VIEWANI
        LD A,(FRAMES)
        AND A
        RET Z
        LD A,(LISTLEN)
        AND A
        RET Z
        CALL PACKCUR
        CALL NOFIRE
        CALL NOKEY
        CALL CASHARR
        LD A,(XSIZE)
        CP 30
        JR NC,view_FS
        LD A,(YSIZE)
        CP 22
        JR NC,view_FS
        LD BC,(XSIZE)
        LD A,32
        SUB C
        RRA 
        AND 15
        INC A
        LD D,A
        LD A,24
        SUB B
        RRA 
        AND 15
        INC A
        LD E,A
        INC B
        INC B
        INC C
        INC C
        LD A,E
        RRCA 
        RRCA 
        RRCA 
        AND #E0
        OR D
        LD L,A
        LD A,E
        AND #18
        OR #40
        LD H,A
        LD (AniAddr+1),HL
        DEC D
        DEC E
        AND A
        CALL WINDOW
        JR view_AL
view_FS LD DE,#0000
        LD BC,#1820
        SCF 
        CALL WINDOW
        CALL CLS
        LD HL,#4000
        LD (AniAddr+1),HL
view_AL
        LD HL,LISTTAB+#100
        LD A,(LISTLEN)
val_1   PUSH AF
        PUSH HL
        LD A,(HL)
        LD (view_DL+1),A
        DEC H
        LD L,(HL)
        LD H,high FRAMTAB
        LD A,(HL)
        CALL OUTFRAM
view_DL LD B,1
val_2   HALT 
        XOR A
        IN A,(254)
        CPL 
        AND 31
        JR NZ,val_E
        CALL INPUTJ
        LD A,C
        AND #70
        JR NZ,val_E
        DJNZ val_2
        POP HL
        POP AF
        INC L
        DEC A
        JR NZ,val_1
        JR view_AL
val_E   POP HL
        POP AF
        CALL WRKBANK
        CALL RESTFON
        CALL NOKEY
        JP RET_ARR
OUTFRAM
        LD (CurSect),A
        CALL SECTADR
AniAddr LD DE,#4000
        LD A,(XSIZE)
ofra_1  PUSH AF
        PUSH DE
        XOR A
        EXA 
        LD A,(YSIZE)
ofra_2  PUSH AF
        PUSH DE
        EXA 
        AND 3
        JR NZ,ofra_N1
        LD C,(HL)
        INC L
        CALL Z,GONEXT
ofra_N1 INC A
        EXA 
        RL C
        JR NC,opfra_6
        RL C
        PUSH BC
        LD C,(HL)
        INC L
        CALL Z,GONEXT
        XOR A
        LD B,8
ofra_3  RL C
        JR NC,ofra_4
        LD A,(HL)
        INC L
        CALL Z,GONEXT
ofra_4  LD (DE),A
        INC D
        DJNZ ofra_3
        POP BC
        JR ofra_4A

opfra_6 RL C
        SBC A,A
        LD B,8
opfra_7 LD (DE),A
        INC D
        DJNZ opfra_7

ofra_4A LD A,D
        DEC A
        CALL TO_ATR
        LD D,A
        LD A,(HL)
        INC L
        CALL Z,GONEXT
        LD (DE),A
        POP DE
        LD A,E
        ADD A,32
        LD E,A
        JR NC,ofra_5
        LD A,D
        ADD A,8
        LD D,A
ofra_5  POP AF
        DEC A
        JR NZ,ofra_2
        POP DE
        POP AF
        INC E
        DEC A
        JR NZ,ofra_1
        RET 
DELETE
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PUSHPOP
        CALL CONFIRM
        JP NZ,del_E
        LD HL,FRAMES
        DEC (HL)
        LD A,(CURFRAM)
        LD L,A
        LD H,high FRAMTAB
        LD A,(HL)
        PUSH HL
        CALL DELFAT
        POP HL
        LD E,L
        LD D,H
        INC HL
del_1   LD A,(HL)
        LD (DE),A
        INC E
        INC L
        JR NZ,del_1
        LD HL,LISTTAB
        LD D,H
        LD E,L
        LD A,(CURFRAM)
        LD C,A
del_2   LD A,(DE)
        CP C
        JR C,del_3
        LD A,(LISTLEN)
        SUB 1
        ADC A,0
        LD (LISTLEN),A
        INC E
        JR NZ,del_2
        JR del_4
del_3   LD A,(DE)
        LD (HL),A
        INC D
        INC H
        LD A,(DE)
        LD (HL),A
        DEC D
        DEC H
        INC L
        INC E
        JR NZ,del_2
del_4   LD A,(LISTLEN)
        AND A
        JR NZ,del_5
        LD (EdiMode),A
del_5   LD A,(FRAMES)
        AND A
        JR Z,del_A
        LD A,(EdiMode)
        AND A
        JR Z,del_7
        LD A,(LISTLEN)
        LD C,A
        LD A,(CURPOS)
        JR C,del_6
        LD A,C
        DEC A
        LD (CURPOS),A
del_6   LD L,A
        LD H,high LISTTAB
        LD A,(HL)
        LD (CURFRAM),A
        CALL POPFRAM
        JR del_9
del_7   LD A,(FRAMES)
        LD C,A
        LD A,(CURFRAM)
        CP C
        JR C,del_8
        LD A,C
        DEC A
        LD (CURFRAM),A
del_8   CALL POPFRAM
del_9   CALL CASHARR
        CALL RESTFON
        CALL OUT_ALL
        CALL OUTMODE
del_9A  LD DE,(FramDes+1)
        LD BC,(FramDes+3)
        SCF 
        CALL WINDOW
        CALL INITARR
        CALL NOMOVE
        SCF 
        RET 
del_A   CALL CASHARR
        CALL RESTFON
        CALL INIT
        CALL CLR_ALL
        CALL outa_IN
        CALL OUTMODE
        JR del_9A
del_E   CALL CASHARR
        CALL RESTFON
        JR del_9A

CONFIRM LD HL,ConfTxt
CONF_HL PUSH HL
        CALL CASHARR
        LD DE,#FFFF
        LD BC,#050F
        AND A
        CALL WINDOW
        POP HL
        CALL TEXT
        LD IX,ConfBut
        CALL OUTBUTZ
        CALL INITARR
        CALL NOMOVE
        LD HL,ConfBut
        LD DE,ConfKey
        XOR A
        JP TESTBUT

ConfTxt DB 1,1,1,"Удалить кадр?",0
ConfBut DB 5,2,2,2,33
        DW CONF_Y
        DB 8,2,2,2,37
        DW CONF_N
        DB 0,0,255,255,255
        DW skip
        DB 255
ConfKey DW #10DF,CONF_Y
        DW #087F,CONF_N
        DB 255

CONF_Y  CALL PCRI
        XOR A
        SCF 
        RET 
CONF_N  CALL PCRI
        OR 2
EXIT_E  SCF 
        RET
        
PCRI	CALL PUSHPOP
	CALL CASHARR
	CALL RESTFON
	JP INITARR
;---------------------
OVERLAY
        CALL NC,PUSHPOP
        LD A,(FRAMES)
        AND A
        CALL NZ,PACKCUR
        LD HL,OvlSORT
        CALL SELFILE
        JP C,ova_EX
        PUSH HL
        LD HL,ShowBox
        RES 3,(HL)
        POP IX
        CALL BUFPAGE
        LD B,(IX+13)
        LD E,(IX+14)
        LD D,(IX+15)
        LD HL,#C000
        CALL LOAD
        LD HL,#C003
        LD DE,OvlHead
ovl_1   LD A,(DE)
        CP (HL)
        JR NZ,ovl_ERR
        INC HL
        INC DE
        AND A
        JR NZ,ovl_1
        LDB (SETPAGE+1),BufPage
        CALL #C000
        LDB (SETPAGE+1),WrkPage
        AND A
        RET 
ovl_ERR LD HL,OE_txt
        AND A
        CALL lani_ER
ova_EX  LD A,(FRAMES)
        AND A
        LD A,(CURFRAM)
        CALL NZ,POPFRAM
        AND A
        RET 

OE_txt  DB 1,1,1,"неверный формат",0

OvlSORT LD A,(IX+8)
        CP "O"
        JR Z,ovs_1
        CP "o"
        RET NZ
ovs_1   LD A,(IX+9)
        CP "V"
        JR Z,ovs_2
        CP "v"
        RET NZ
ovs_2   LD A,(IX+10)
        CP "A"
        JR Z,ovs_3
        CP "a"
        RET NZ
ovs_3   LD A,(IX+13)
        CP #40
        RET NC
        XOR A
        RET 

OvlHead DB "AniE overlay",0
;--------------------------
LIST
        CALL NC,PUSHPOP
        LD A,(FRAMES)
        AND A
        RET Z
        CALL PACKCUR

        CALL CASHARR
        LD DE,#FFFF
        LD BC,#1213
        AND A
        CALL WINDOW

        LD DE,#0101
        LD BC,#100B
        LD A,6
        CALL CLR_BOX

        LD A,(CURPOS)
        SUB 8
        JR NC,lst_A1
        XOR A
lst_A1  LD L,A
        LD A,(LISTLEN)
        SUB 16
        JR NC,lst_A1A
        XOR A
lst_A1A CP L
        JR C,lst_A2
        LD A,L
lst_A2  LD (UpList),A
        LD L,A
        LD A,(CURPOS)
        SUB L
        LD (PosList),A
        LD A,#FF
        LD (INL_CRS+1),A
        LD IX,ListBut
        CALL OUTBUTZ
        CALL PRN_LST
        LD C,#17
        CALL LISTCRS

        CALL INITARR
        CALL NOMOVE
        LD HL,ListBut
        LD DE,ListKey
        LD BC,IN_LIST
        OR 2
        CALL TESTBUT

        LD A,(PosList)
        LD L,A
        LD A,(UpList)
        ADD A,L
        LD (CURPOS),A
        LD A,1
        LD (EdiMode),A

        CALL REPOPER
        CALL lani_E
        CALL CASHARR
        CALL OUT_ALL
        CALL OUTMODE
        CALL INITARR
        CALL NOMOVE
        AND A
        RET 

IN_LIST CALL ARR_INW
        DEC D
        DEC E
        LD A,D
        CP 11
        JR NC,inl_FF
        LD A,E
        CP 16
        JR NC,inl_FF
        LD E,A
        LD A,(LISTLEN)
        DEC A
        CP E
        LD A,E
        JR NC,inl_A
inl_FF  LD A,#FF
inl_A   PUSH AF
        CALL INL_CRS
        POP AF
        LD (INL_CRS+1),A
INL_CRS LD A,#FF
        CP #FF
        RET Z
        INC A
        LD E,A
        LD D,1
        CALL INWINAT
        EX DE,HL
        LD B,11
inlc_1  LD A,(HL)
        XOR #08
        LD (HL),A
        INC L
        DJNZ inlc_1
        RET 

CHA_LP  LD A,(INL_CRS+1)
        CP #FF
        RET Z
        LD H,A
        LD A,(PosList)
        CP H
        JR Z,D_CLICK
        LD A,H
cha_lp  PUSH AF
        HALT 
        CALL INL_CRS
        LD C,6
        CALL LISTCRS
        LD A,#FF
        LD (INL_CRS+1),A
        POP AF
        LD (PosList),A
        LD C,#17
        CALL LISTCRS
D_CLICK CALL INPUTJ
        LD A,C
        AND #40
        RET Z
        SCF 
        RET 

PRN_LST LD HL,#0101
        LD A,(UpList)
        LD C,A
        LD B,high LISTTAB
        LD A,16
plis_1  PUSH AF
        LD (PrnPos+1),HL
        LD A,C
        PUSH BC
        CALL PRN_NUM
        POP BC
        LD A,":"
        CALL PRINT
        LD A,(LISTLEN)
        DEC A
        CP C
        JR NC,plis_Y
        CALL trePrn
        LD A,":"
        CALL PRINT
        CALL trePrn
        JR plis_N
plis_Y  LD A,(BC)
        PUSH BC
        CALL PRN_NUM
        POP BC
        PUSH BC
        LD A,":"
        CALL PRINT
        INC B
        LD A,(BC)
        CALL PRN_NUM
        POP BC
plis_N  INC C
        POP AF
        INC L
        DEC A
        JR NZ,plis_1
        RET
        
trePrn	call PRINTS
	call PRINTS
	jp PRINTS

UpList  DB 0
PosList DB 0

LISTCRS LD A,(PosList)
        INC A
        LD E,A
        LD D,1
        CALL INWINAT
        EX DE,HL
        LD B,11
lcrs_1  LD (HL),C
        INC L
        DJNZ lcrs_1
        RET 

LIST_DN LD A,(PosList)
        INC A
        LD L,A
        LD A,(UpList)
        ADD A,L
        LD H,A
        LD A,(LISTLEN)
        DEC A
        CP H
        CCF 
        RET NC
        LD A,L
        CP 16
        JP C,cha_lp
        LD A,(UpList)
        INC A
        JR lup_A

LIST_UP LD A,(PosList)
        SUB 1
        JP NC,cha_lp
        LD A,(UpList)
        AND A
        RET Z
        DEC A
lup_A   LD (UpList),A
        HALT 
        CALL INL_CRS
        CALL CASHARR
        LD A,#FF
        LD (INL_CRS+1),A
        CALL PRN_LST
        CALL INITARR
        CALL NOMOVE
        AND A
        RET 

LIST_DF CALL NC,PUSHPOP
        CALL LISTADR
        LD A,(HL)
        SUB 1
        CCF 
        RET NC
        LD (HL),A
        JR LIST_RL
LIST_IF CALL NC,PUSHPOP
        CALL LISTADR
        LD E,(HL)
        LD A,(FRAMES)
        DEC A
        CP E
        RET Z
        INC E
        LD (HL),E
        JR LIST_RL
LIST_ID CALL NC,PUSHPOP
        CALL LISTADR
        INC H
        LD A,(HL)
        CP #FE
        RET NC
        INC A
        LD (HL),A
        JR LIST_RL
LIST_DD CALL NC,PUSHPOP
        CALL LISTADR
        INC H
        LD A,(HL)
        DEC A
        AND A
        RET Z
        LD (HL),A
LIST_RL LD A,(PosList)
        LD L,A
        LD H,1
        INC L
        LD (PrnPos+1),HL
        DEC L
        LD A,L
        CALL PRN_NUM
        LD A,":"
        CALL PRINT
        LD H,high LISTTAB
        LD A,(HL)
        CALL PRN_NUM
        LD A,":"
        CALL PRINT
        INC H
        LD A,(HL)
        CALL PRN_NUM
        AND A
        RET 

LISTADR LD A,(PosList)
        LD L,A
        LD A,(UpList)
        ADD A,L
        LD L,A
        LD H,high LISTTAB
        RET 

LIST_MD CALL NC,PUSHPOP
        LD A,(PosList)
        LD L,A
        LD A,(UpList)
        ADD A,L
        LD L,A
        LD A,(LISTLEN)
        DEC A
        CP L
        RET Z
        CALL CHNG_NX
        CALL LIST_DN
        JR limu_1

LIST_MU CALL NC,PUSHPOP
        LD A,(PosList)
        LD L,A
        LD A,(UpList)
        ADD A,L
        AND A
        RET Z
        CALL LIST_UP
        CALL CHNG_NX
limu_1  CALL CASHARR
        CALL PRN_LST
        CALL INITARR
        CALL NOMOVE
        AND A
        RET 

CHNG_NX CALL LISTADR
        LD E,(HL)
        INC H
        LD D,(HL)
        INC L
        LD B,(HL)
        LD (HL),D
        DEC H
        LD C,(HL)
        LD (HL),E
        DEC L
        LD (HL),C
        INC H
        LD (HL),B
        RET 

LIST_DL CALL NC,PUSHPOP ; удалить позицию из списка
        LD A,(LISTLEN)
        SUB 1
        RET Z
        LD (LISTLEN),A
        CALL LISTADR
        LD E,L
        LD D,H
        INC L
lidl_1  LD A,(HL)
        LD (DE),A
        INC H
        INC D
        LD A,(HL)
        LD (DE),A
        DEC H
        DEC D
        INC E
        INC L
        JR NZ,lidl_1
        CALL NOKEY
        LD A,(PosList)
        LD L,A
        LD A,(UpList)
        ADD A,L
        LD L,A
        LD A,(LISTLEN)
        DEC A
        CP L
        CALL C,LIST_UP
        JR limu_1

LIST_IS CALL NC,PUSHPOP
        LD A,(LISTLEN)
        CP 254
        RET Z
        INC A
        LD (LISTLEN),A
        CALL LISTADR
        LD C,(HL)
        INC H
        LD B,(HL)
        DEC H
        INC L
liis_1  LD A,(HL)
        LD (HL),C
        LD C,A
        INC H
        LD A,(HL)
        LD (HL),B
        LD B,A
        DEC H
        INC L
        JR NZ,liis_1
        CALL NOKEY
        JR limu_1
ListBut
        DB 13,1,2,2,6
        DW LIST_MU
        DB 16,1,2,2,7
        DW LIST_MD
        DB 13,4,2,2,8
        DW LIST_DD
        DB 16,4,2,2,9
        DW LIST_ID
        DB 13,10,2,2,10
        DW LIST_IS
        DB 16,10,2,2,37
        DW LIST_DL
        DB 13,7,2,2,5
        DW LIST_DF
        DB 16,7,2,2,4
        DW LIST_IF

        DB 1,1,11,16,255
        DW CHA_LP

        DB 0,0,19,18,255
        DW skip
        DB 0,0,255,255,255
        DW 0
        DB 255
ListKey
        DB 1
        DW #08EF,LIST_UP
        DW #10EF,LIST_DN
        DW #10F7,LIST_DD
        DW #04EF,LIST_ID
        DB 255
;-----------------------
CHA_CHC
        LD B,2
        JR chas_1
CHA_SHB LD B,1
chas_1  LD A,(ShowBox)
        XOR B
        LD (ShowBox),A
        CALL SHOWBOX
        CALL CASHARR
        CALL OUT_LMP
        CALL NOKEY
        CALL INITARR
        CALL NOMOVE
        AND A
        RET 

OUT_LMP LD HL,#5A1B
        LD DE,32
        LD A,(ShowBox)
        LD BC,#0204
        CALL olmp
olmp    RRA 
        JR C,olm_S
        LD (HL),B
        ADD HL,DE
        RET 
olm_S   LD (HL),C
        ADD HL,DE
        RET 

SHOWBOX
        LD A,(FRAMES)
        AND A
        JR Z,sbox_N
        LD A,(ShowBox)
        RRA 
        JR NC,sbox_N
showbox LD DE,(ARROWX)
        LD HL,BoxTab
        LD BC,#1900
sbox_1  LD A,D
        SUB (HL)
        INC HL
        CP 32
        JR NC,sbox_2
        LD A,E
        SUB (HL)
        CP 32
        JR C,sbox_Y
sbox_2  INC HL
        INC HL
        INC HL
        INC C
        DJNZ sbox_1
sbox_N  LD C,#FF
sbox_Y  LD A,(sbox_NR+1)
        CP C
        RET Z
        PUSH BC
        CALL CASHARR
        CALL sbox_NR
        POP BC
        LD A,C
        LD (sbox_NR+1),A
        CALL sbox_NR
        JP INITARR

sbox_NR LD A,#FF
        CP #FF
        RET Z
        LD HL,BoxTab+2
        ADD A,A
        ADD A,A
        ADD A,L
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        LD DE,Corn_UL
        CALL CORNER
        INC L
        INC L
        INC L
        CALL CORNER
        LD A,L
        ADD A,96
        LD L,A
        SBC A,A
        AND 8
        ADD A,H
        LD H,A
        CALL CORNER
        DEC L
        DEC L
        DEC L
CORNER  PUSH HL
        LD B,8
corn_1  LD A,(DE)
        XOR (HL)
        LD (HL),A
        INC DE
        INC H
        DJNZ corn_1
        POP HL
        RET 

BoxTab  DW #0818,#4061
        DW #2818,#4065
        DW #4818,#4069
        DW #6818,#406D
        DW #8818,#4071

        DW #0838,#40E1
        DW #2838,#40E5
        DW #4838,#40E9
        DW #6838,#40ED
        DW #8838,#40F1

        DW #0858,#4861
        DW #2858,#4865
        DW #4858,#4869
        DW #6858,#486D
        DW #8858,#4871

        DW #0878,#48E1
        DW #2878,#48E5
        DW #4878,#48E9
        DW #6878,#48ED
        DW #8878,#48F1

        DW #0898,#5061
        DW #2898,#5065
        DW #4898,#5069
        DW #6898,#506D
        DW #8898,#5071

Corn_UL DB #FF,#FF,#C0,#C0,#C0,#C0,#C0,#C0
        DB #FF,#FF,#03,#03,#03,#03,#03,#03
        DB #03,#03,#03,#03,#03,#03,#FF,#FF
        DB #C0,#C0,#C0,#C0,#C0,#C0,#FF,#FF
;-----------------------

SBAR_H  LD A,(FRAMES)
        AND A
        LD A,(XSIZE)
        CP 5
        CCF 
        RET NC
hba_0   LD A,(BX_TAB+5)
        AND A
        RRA 
        ADD A,8
        LD B,A
        LD A,(ARROWX)
        SUB B
        JR NC,hba_2
        XOR A
hba_2   CP 160
        JR C,hba_3
        LD A,160
hba_3   LD E,A
        LD BC,#2000
        LD HL,BX_TAB
        CALL FIND_C
        LD A,(XSIZE)
        SUB 5
        CP C
        JR NC,hba_4
        LD C,A
hba_4   LD A,(XPOS)
        CP C
        JR Z,hba_5
        LD A,C
        LD (XPOS),A
        CALL CASHARR
        CALL OUTEDIT
        CALL OUTVIEW
        CALL OUTXBAR
        CALL INITARR
hba_5   CALL TESTARR
        JR C,hba_0
        RET 

SBAR_V  LD A,(FRAMES)
        AND A
        RET Z
        LD A,(YSIZE)
        CP 5
        CCF 
        RET NC
vba_0   LD A,(BY_TAB+5)
        AND A
        RRA 
        ADD A,24
        LD B,A
        LD A,(ARROWX+1)
        SUB B
        JR NC,vba_2
        XOR A
vba_2   CP 160
        JR C,vba_3
        LD A,160
vba_3   LD E,A
        LD HL,BY_TAB
        LD BC,#1800
        CALL FIND_C
        LD A,(YSIZE)
        SUB 5
        CP C
        JR NC,vba_3A
        LD C,A
vba_3A  LD A,(YPOS)
        CP C
        JR Z,vba_4
        LD A,C
        LD (YPOS),A
        CALL CASHARR
        CALL OUTEDIT
        CALL OUTVIEW
        CALL OUTYBAR
        CALL INITARR
vba_4   CALL TESTARR
        JR C,vba_0
        RET 

FIND_C  LD A,(HL)
        CP E
        RET NC
        INC HL
        INC C
        DJNZ FIND_C
        RET 
;-----------------------
FUNC
        CP MaxFunc
        RET NC
        PUSH HL
        ADD A,A
        LD HL,FAdrTab
        ADD A,L
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        LD (FCallAd+1),HL
        POP HL
FCallAd CALL skip
        PUSH AF
        CALL SETPAGE
        POP AF
        RET 

FAdrTab
        DW INIT         ;  0:переинит всего
        DW F_POPF       ;  1:вынуть кадр C
        DW F_POPL       ;  2:вынуть кадр с позиции C
        DW PACKCUR      ;  3:упаковать текущий
        DW PACKNEW      ;  4:упаковать как новый
        DW F_ADDP       ;  5:новая позиция frame=C delay=B
        DW SELFILE      ;  6:выбор файла (HL - прога.сортировки)
        DW LOAD         ;  7:load: HL=addr, DE=TRS, B=sectors
        DW SAVE         ;  8:save: (same)
        DW F_OUTAL      ;  9:вывод всего на экран
        DW INITARR      ; 10:вывести стрелу
        DW CASHARR      ; 11:убрать стрелу
        DW TESTARR      ; 12:тестировать стрелу
        DW BAR_PAR      ; 13:параметры scroll-bar'a
MaxFunc EQU ($-FAdrTab)/2

F_OUTAL LD A,(CASHARR)
        PUSH AF
        CALL CASHARR
        CALL OUT_ALL
        POP AF
        AND A
        CALL Z,INITARR
        AND A
        RET 

F_ADDP  CALL CP_FRAM
        RET C
        LD A,B
        inc a
        SCF 
        RET Z
        LD A,(LISTLEN)
        CP 250
        CCF 
        RET C
        LD L,A
        LD H,high LISTTAB
        LD (HL),C
        INC H
        LD (HL),B
        INC A
        LD (LISTLEN),A
        AND A
        RET 

F_POPL  CALL CP_LIST
        RET C
        LD B,high LISTTAB
        LD A,C
        LD (CURPOS),A
        LDB C,(BC)
F_POPF  CALL CP_FRAM
        RET C
        LD A,C
        LD (CURFRAM),A
        CALL POPFRAM
        AND A
        RET 

CP_LIST LD A,(LISTLEN)
        JR cp_all
CP_FRAM LD A,(FRAMES)
cp_all  CP C
        RET C
        RET NZ
        SCF 
        RET 

